//
//  PhotoPuzzleAppDelegate.m
//  PhotoPuzzle
//
//  Created by Gustav Lindbergh on 2011-07-13.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PhotoPuzzleAppDelegate.h"
#import "AllPuzzlesController.h"

@implementation PhotoPuzzleAppDelegate


@synthesize window;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    
    // Hmta sparade pussel
    NSString *puzzlesPath = [self puzzlesArrayPath];
    NSMutableArray *puzzlesArray = [NSKeyedUnarchiver unarchiveObjectWithFile:puzzlesPath];
    
    if (!puzzlesArray)
        puzzlesArray = [NSMutableArray array];
    
    
    startController = [[AllPuzzlesController alloc] init];
    [startController setPuzzles:puzzlesArray];
    
    UINavigationController *navController = [[UINavigationController alloc]
                                             initWithRootViewController:startController];
    [navController.navigationBar setTintColor:[UIColor blackColor]];
    [navController.toolbar setTintColor:[UIColor blackColor]];
    //[navController.navigationBar setTranslucent:YES];
    
    
    [window setRootViewController:navController];
    [navController release];
    
//    puzzleController = [[PuzzleController alloc] init];
//    [window addSubview:puzzleController.view];
                        
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    [self archivePuzzles];
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    [self archivePuzzles];
}

- (void)dealloc
{
    [window release];
    [super dealloc];
}

- (NSString *)puzzlesArrayPath
{
    return pathInDocumentDirectory(@"Puzzles.data");
}

- (void) archivePuzzles
{
    NSString *puzzlesPath = [self puzzlesArrayPath];
    NSMutableArray *puzzlesArray = [startController puzzles];
    [NSKeyedArchiver archiveRootObject:puzzlesArray toFile:puzzlesPath];
}

@end
